part of 'package:splayer/src/splayer.dart';

class FullScreenView extends StatefulWidget {
  final String tag;

  const FullScreenView({
    required this.tag,

    super.key,
  });

  @override
  State<FullScreenView> createState() => _FullScreenViewState();
}

class _FullScreenViewState extends State<FullScreenView>
    with TickerProviderStateMixin {
  late PodGetXVideoController _podCtr;
  @override
  void initState() {
    _podCtr = Get.find<PodGetXVideoController>(tag: widget.tag);
    _podCtr.fullScreenContext = context;
    _podCtr.keyboardFocusWeb?.removeListener(_podCtr.keyboadListner);

    super.initState();
  }

  @override
  void dispose() {
    _podCtr.keyboardFocusWeb?.requestFocus();
    _podCtr.keyboardFocusWeb?.addListener(_podCtr.keyboadListner);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {

    final loadingWidget = _podCtr.onLoading?.call(context) ??
        const CircularProgressIndicator(
          backgroundColor: Colors.black87,
          color: Colors.white,
          strokeWidth: 2,
        );

    return PopScope(
      canPop: false,
      onPopInvoked: (d) async {
        if (kIsWeb) {
          await _podCtr.disableFullScreen(
            context,
            widget.tag,
            enablePop: false,
          );
        }
        if (!kIsWeb) await _podCtr.disableFullScreen(context, widget.tag);

      },
      child:Scaffold(
        body:  GetBuilder<PodGetXVideoController>(
          tag: widget.tag,
          builder: (podCtr) =>

          podCtr.videoCtr == null
              ? Center(
              child: loadingWidget)
              : podCtr.videoCtr!.value.isInitialized
              ?  _PodCoreVideoPlayer(

            tag: widget.tag,
            videoPlayerCtr: podCtr.videoCtr!,
            videoAspectRatio:_podCtr.videoCtr!.value.aspectRatio,
          )
              : Center(child: loadingWidget),
        ),
      ),
    );
  }
}
